#ifndef _QHVC_INTERACT_H_
#define _QHVC_INTERACT_H_

#pragma once

#include "QHVCSdk.h"
#include "QHVCInteractCallback.h"
#include "QHVCInteractConstant.h"

namespace QHVC
{
    namespace INTERACT
    {
        namespace QHVCInteract {

            /**
            * ȡSDK汾
            *
            * @return SDK汾
            */
            QHVC_API const char* GetVersion();

#pragma region 

            /**
            * ùҵϢ÷Ҫʵ֮ǰãҵҪһЩҪϢҵ֡ͳʹá
            *
            * @param channelId Idֹ˾ӵжӦáֱΪӦó򿪷ǩûУֱ롣
            * @param appKey ֱΪӦó򿪷ǩApp KeyûУֱ롣
            * @param userSign  ûǩֱṩ㷨ɴ User Signڷû֤
            */
            QHVC_API void SetPublicServiceInfo(const char* channelId, const char*  appKey, const char*  userSign);

            /**
            * ػֱݣ׼ø÷ǰȵsetPublicServiceInfoҵϢ׼
            * ڸ÷úܵʵ÷첽ִУصִִ֮ʵ
            *
            * @param roomId           Id64ֽڵַΪֵַ֧Χ: a-z,A-Z,0-9
            * @param userId           ûid, ע⣺****֣9λ֣֤Ψһ
            * @param sessionId        ỰIDڱʶҵỰÿһ֮󣬸ֵҪ
            * @param optionInfo       ѡֵ䣬ʹjson·ֱܵȿֵͨãҵ׼ʹƵƵֱ
            *                         ͨapplyforBypassLiveAddressӿ
            *                         : {"push_addr":"xxx", "pull_addr";"xxxx"},μ
            *                         {@link QHVC#INTERACT#ENGINE_OPTION}塣
            * @param interactCallBack ص
            * @return 0:ʾɹ,ʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int LoadEngine(const char*  roomId, const char*  userId, const char*  sessionId, const char* optionInfo,
                const IQHVCInteractCallback* interactCallBack);

            /**
            * ͷ
            */
            QHVC_API void ReleaseEngine();


            /**
            * ÷ûͨƵͬһƵڵûԻͨûͬһƵ
            * ȺġͨУûleaveChannel ˳ǰͨܽһƵ
            *
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int JoinChannel();


            /**
            * 뿪Ƶ
            * Ҷϻ˳ͨjoinChannel󣬱leaveChannelԽͨܽһͨܵǰ
            * ǷͨУԵleaveChannelûиáleaveChannelѻỰصԴͷŵleaveChannel
            * 첽÷ʱû˳Ƶ˳ƵSDKᴥIQHVCInteractCallBack.onLeaveChannel()
            *
            * @return 0 ɹ, ʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int LeaveChannel();

            /**
            * ÷Ƶģʽ(Profile) SDK֪Ӧóʹó Ӷʹ
            * ͬŻֶΡ
            * ע
            *     1. ͬһƵֻͬʱһģʽ
            *     2. ÷ڽƵǰãƵЧ
            *
            * @param profile ָƵͨģʽ(profile)֧ģʽ
            *                QHVC#INTERACT#CHANNEL_PROFILE_COMMUNICATION (ͨģʽĬ)
            *                QHVC#INTERACT#CHANNEL_PROFILE _LIVE_BROADCASTING (ֱģʽ)
            *                QHVC#INTERACT#CHANNEL_PROFILE_GAME (Ϸģʽ)
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetChannelProfile(CHANNEL_PROFILE profile);

            /**
            * Ƶģʽ, ÷ڿƵģʽڼƵǰͨеãڼƵǰãԶ
            * ƵģʽͨеƵģʽлΪƵģʽ disablevideo ɹر
            * Ƶģʽ
            *
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int EnableVideo();

            /**
            * Ƶģʽ, ÷ڹرƵƵģʽڼƵǰͨеãڼƵǰ
            * ãԶƵģʽͨеƵģʽлΪƵƵģʽ
            * enablevideo ɿƵģʽ
            *
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int DisableVideo();

            /**
            * /ñƵܡ÷ֻƵ÷Ҫͷ
            *
            * @param enabled true: ñƵĬϣ false: ñƵ
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int EnableLocalVideo(bool enabled);

            /**
            * ÷ûƵŻѡ
            *
            * @param preferFrameRateOverImageQuality true: ʺȱ֤(Ĭ),false: ʺȱ֤
            * @return 0 ɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetVideoQualityParameters(bool preferFrameRateOverImageQuality);

            /**
            * ÷ƵԤڿԤǰȵ setupLocalVideo Ԥڼ
            * ԣұ enableVideo Ƶܡڵ joinChannel Ƶ֮ǰ
            * startPreview ƵԤڵ leaveChannel ˳Ƶ֮󱾵ԤȻ
            * ״̬ҪرձԤҪ stopPreview
            * עʹSDKɼƵҵԲɼƵʱ벻Ҫá
            *
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int StartPreview();

            /**
            * ÷ֹͣƵԤ
            *
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int StopPreview();

            /**
            * ģʽ
            * ÷ģʽ(ĬΪ״̬)
            *
            * @return 0 ɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int EnableAudio();

            /**
            * رģʽ
            *
            * @return 0 ɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int DisableAudio();

            /**
            * 
            * ÷Ƶʡ뷽ʽʣԼʹó
            * ע1. ÷Ҫ joinChannel ֮ǰúãjoinChannel ֮òЧ
            *     2. ͨģʽ£÷ profile Ч scenario Ч
            *     3. ͨźֱģʽ£ʣʣӦĵͨ÷õһ
            *
            * @param profile Ƶʡ뷽ʽ
            * @param scenario ƵӦó
            * @return 0 ɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetAudioProfile(AUDIO_PROFILE profile, AUDIO_SCENARIO scenario);

            /**
            * һЩSDK
            *
            * @param options jsonʽ
            * @return 0 ɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetParameters(const char* options);

            /**
            * úлûģʽ
            * ڼƵǰûҪͨùڻģʽĬϣ
            * ڼƵûͨлûģʽ
            * ÷ֱģʽЧ
            *
            * @param role ֱûɫ QHVC#INTERACT#CLIENT_ROLE_BROADCASTER :
            *             QHVC#INTERACT#CLIENT_ROLE_GUEST α
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetClientRole(CLIENT_ROLE role);

            /**
            * ɫ
            *
            * @param role ɫƣҪƵһ£б
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetCloudControlRole(const char* role);

            /**
            * ÷ñƵʾϢӦóͨô˽ӿڰ󶨱ƵʾӴ(view)
            * ƵʾģʽӦó򿪷У ͨڳʼø÷бƵã
            * ȻټƵ˳Ƶ󣬰ȻЧҪ󶨣ָ(NULL)View
            *  setupLocalVideo
            *
            * @param view       ƵʾӴ
            * @param renderMode Ƶʾģʽ
            *                   QHVC#INTERACT#RENDER_MODE_HIDDEN (1): ƵߴʾӴߴ粻һ£ƵᰴʾӴıܱ߲üͼӴ
            *                   QHVC#INTERACT#ENDER_MODE_FIT(2): ƵߴʾӴߴ粻һ£ڱֳȵǰ£ƵźӴ
            *                   QHVC#INTERACT#RENDER_MODE_ADAPTIVE(3)ԼͶԷԼͶԷǺʹRENDER_MODE_HIDDENԷԼһ
            *                   һʹ RENDER_MODE_FIT
            * @param uid        ûID,  joinchannel е uid һ¡
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetupLocalVideo(HWND view, RENDER_MODE renderMode, const char* uid);

            /**
            * ÷Զûʾͼ趨 uid ָûĸͼʾһ·ҵʲôʱʾĳûİͼԵremoveRemoteVideo
            * ˳Ƶ SDK Զûİ󶨹ϵ
            *
            * @param view       ƵʾӴ
            * @param renderMode Ƶʾģʽ
            *                   QHVC#INTERACT#RENDER_MODE_HIDDEN (1): ƵߴʾӴߴ粻һ£ƵᰴʾӴıܱ߲üͼӴ
            *                   QHVC#INTERACT#RENDER_MODE_FIT(2): ƵߴʾӴߴ粻һ£ڱֳȵǰ£ƵźӴ
            *                   QHVC#INTERACT#RENDER_MODE_ADAPTIVE(3)ԼͶԷԼͶԷǺʹ RENDER_MODE_HIDDENԷԼһһʹRENDER_MODE_FIT
            * @param uid        û IDָԶƵĸû
            * @param streamId   IDָԶƵID
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetupRemoteVideo(HWND view, RENDER_MODE renderMode, const char* uid, const char* streamId);

            /**
            * ÷ڽԶûʾͼԶû뿪Ƶ󣬵ô˷
            *
            * @param streamId ָԶƵID
            * @param uid      ûIDָԶƵĸû
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int RemoveRemoteVideo(const char* streamId, const char* uid);

            /**
            * ÷ñƵʾģʽӦóԶεô˷ʾģʽ
            * עʹSDKɼƵҵԲɼƵʱ벻Ҫá
            *
            * @param mode Ƶʾģʽ
            *             QHVC#INTERACT#RENDER_MODE_HIDDEN (1): ƵߴʾӴߴ粻һ£ƵᰴʾӴıܱ߲üͼӴ
            *             QHVC#INTERACT#RENDER_MODE_FIT(2): ƵߴʾӴߴ粻һ£ڱֳȵǰ£ƵźӴ
            *             QHVC#INTERACT#RENDER_MODE_ADAPTIVE(3)ԼͶԷԼͶԷǺʹRENDER_MODE_HIDDENԷԼһһʹ RENDER_MODE_FIT
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetLocalRenderMode(RENDER_MODE mode);

            /**
            * ÷ñƵڿԤǰáڿԤãҪ¿ԤЧ
            * SetupRemoteVideoǰ
            * @param mode ģʽ͡@link QHVC#INTERACT#VIDEO_MIRROR_MODE
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetLocalVideoMirrorMode(VIDEO_MIRROR_MODE mode);

            /**
            * ÷ԶƵʾģʽӦóԶεô˷ʾģʽ
            *
            * @param uid  û ID
            * @param mode Ƶʾģʽ
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetRemoteRenderMode(const char*  uid, RENDER_MODE mode);

            /**
            * ÷Ƶ(Profile)ÿԶӦһƵֱʡ֡ʡʵȡ豸ͷ
            * ָ֧ķֱʱ SDK ԶѡһʵͷֱʣǱֱȻ setVideoProfile ָġ
            * ע
            *       1. Ӧڵ joinChannel/startPreview ǰƵԡ
            *       2. ÷ñԣܸʾԲһ£ֱΪ 640x480
            *       תΪ 90 ȣʾķֱΪģʽ
            *
            * @param profile            Ƶ(Profile)QHVCInteractConstant.VideoProfileеĶ塣
            * @param swapWidthAndHeight Ƿ񽻻͸ߡ    true͸  false͸(Ĭ)
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetVideoProfile(VIDEO_PROFILE profile, bool swapWidthAndHeight);

            /**
            * ÷Ƶ
            *
            * @param width Ƶֱ-
            * @param height Ƶֱ-
            * @param frameRate Ƶ֡
            * @param bitrate Ƶ
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetVideoProfileEx(int width, int height, int frameRate, int bitrate);

            /**
            * ͣ/ָͱƵ÷/ֹ緢ͱƵ
            * ע ÷Ӱ챾Ƶȡûнͷ
            *
            * @param muted True: ͱƵ  False: ͱƵ
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int MuteLocalVideoStream(bool muted);

            /**
            * ͣ/ָƵ/ֹ˵Ƶ
            * ע ÷ӰƵĽգֻǲƵ
            *
            * @param muted True: ֹͣŽյƵ False: ŽյƵ
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int MuteAllRemoteVideoStreams(bool muted);

            /**
            * ͣ/ָָԶƵ/ָֹԶƵ
            * ע ÷ӰƵĽգֻǲƵ
            *
            * @param uid   ָû
            * @param muted True: ֹͣŽյƵ False: ŽյƵ
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int MuteRemoteVideoStream(const char* uid, bool muted);

            /**
            * ˵ʾ÷ SDK Ӧóǰ˭˵Լ˵ߵ
            *
            * @param interval ָʾʱ
            *                 <= 0ʾ
            *                 > 0ʾļλΪ롣õ 200 롣
            *                 ø÷ƵǷ˵˵ʾص (onAudioVolumeIndication) صаõļʱ䷵ʾ
            * @param smooth ƽϵĬϿΪ3
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int EnableAudioVolumeIndication(int interval, int smooth);

            /**
            * /ȡ÷/ֹ緢ͱƵ
            * ע ÷Ӱ¼״̬ûн˷硣
            *
            * @param muted True˷羲  Falseȡ
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int MuteLocalAudioStream(bool muted);

            /**
            * Զû/Զûȡ/ֹԶûƵ
            * ע ÷ӰƵĽգֻǲƵ
            *
            * @param muted True˷羲  Falseȡ
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int MuteAllRemoteAudioStreams(bool muted);

            /**
            * ָԶû/ָԶûȡ/ֹԶûƵ
            * ע ÷ӰƵĽգֻǲƵ
            *
            * @param uid   ָû
            * @param muted True˷羲 Falseȡ
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int MuteRemoteAudioStream(const char* uid, bool muted);

#pragma endregion 

#pragma region ˫

            /**
            * ʹ˫/ģʽ
            *
            * @param enabled ָ˫ߵģʽ true˫ falseĬϣ
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int EnableDualStreamMode(bool enabled);

            /**
            * СĲڿ˫ģʽʱЧ
            * СֱҪʹĳɱ 360*640С 180*320СҪ̫
            * ע ȷjoinChannel֮ǰá
            *
            * @param width   ƵĿ
            * @param height  ƵĿ
            * @param fps     ֡
            * @param bitrate  (λkbps)
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetLowStreamVideoProfile(int width, int height, int fps, int bitrate);

            /**
            * ƵСл, ÷ָԶûƵСʹø÷ԸƵڵĴС̬Ӧ
            * ƵĴСԽԼͼԴ״̬ĵSDK ĬյƵСʡ
            * ʹƵñл
            *
            * @param uid         û ID
            * @param streamLevel ƵСQHVCInteractConstant.VIDEO_STREAM_LEVEL_HIGH (0): Ƶ
            *                                    QHVCInteractConstant.VIDEO_STREAM_LEVEL_LOW (1): ƵС
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetRemoteVideoStream(const char* uid, VIDEO_STREAM_LEVEL streamLevel);

#pragma endregion ˫

#pragma region 

            /**
            * N+1·תƣ1·+N·ϢԤӿ
            * ȷҪjoinChannel֮ǰá
            *
            * @param mixStreamConfig 
            * @param streamLifeCycle ڣ԰󶨷
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetMixStreamInfo(const MixStreamConfig* mixStreamConfig, STREAM_LIFE_CYCLE streamLifeCycle);

            /**
            * תN+1·ʱºƵ
            * ע1. ȷIQHVCInteractCallBack.onFirstRemoteVideoFrame()ӿУ֮󣩣ø÷
            *     2count 10
            *
            * @param mixStreamInfos ϢȷеƵƵ
            * @param count mixStreamInfosĴС
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetVideoCompositingLayout(const MixStreamRegion* mixStreamInfos, int count);

            /**
            * ȡ
            *
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int ClearVideoCompositingLayout();

#pragma endregion 

#pragma region ȾԲɼ
            /**
            * ñƵⲿȾҵȾƵݻصӿ
            * @param pCallback ƵصcallbackͨصزɼƵݣʵաȾ滻Բɼȣ@link QHVC#INTERACT#IQHVCInteractLocalVideoRenderCallback
            *
            * @return 0:  óɹʾʧܣ@link QHVC#INTERACT#ERR
            */

            QHVC_API int SetLocalVideoRenderCallback(IQHVCInteractLocalVideoRenderCallback* pCallback);

            /**
            * ԶƵʹⲿȾ
            * @param uid                    û IDָԶƵĸû
            * @param streamId               id
            *
            * @return 0:  óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetRemoteVideoExternalRender(const char* userId, const char* streamId);

            /**
            * ԶƵⲿȾҵȾƵصӿ
            * @param pCallback ԶƵصcallback ͨصʵȾȣ@link QHVC#INTERACT#IQHVCInteractRemoteVideoRenderCallback
            *
            * @return 0:  óɹʾʧܣ@link QHVC#INTERACT#ERR
            */

            QHVC_API int SetRemoteVideoRenderCallback(IQHVCInteractRemoteVideoRenderCallback* pCallback);

            /**
            * ÷Ƶݶصcallback
            * @param pCallback ݻص@link QHVC#INTERACT#IQHVCInteractAudioFrameCallback
            *
            * @return 0:  óɹʾʧܣ@link QHVC#INTERACT#ERR
            */

            QHVC_API int SetAudioFrameCallback(IQHVCInteractAudioFrameCallback* pCallback);


            /**
            * ҵƵݲɼȷ{@link #LoadEngine}ǰãĬϹرա
            */

            QHVC_API int OpenCollectingData();

            /**
            * رݲɼȷ{@link #LoadEngine}ǰ
            */
            QHVC_API int CloseCollectingData();


            /**
            * ÷sdkԲɼ
            * @param videoFrame Ƶ
            *
            * @return 0:  óɹʾʧܣ@link QHVC#INTERACT#ERR
            */

            QHVC_API int IncomingCollectingCapturedData(VideoFrame* videoFrame);
#pragma endregion ȾԲɼ

#pragma region Ƶ߼ӿ-Ļ

            /**
            * Ļ÷Ļָڣָ:
            *     Ļ:  hWnd Ϊ 0ҽ rect Ϊ null
            *     ָ:  hWnd Ϊ 0ÿڶһ 0  hWnd
            *     ָ:  hWnd Ϊ 0ҽ rect Ϊ null ָ ָǹĻĳĿǰݲָָֹ֧
            *
            * @param hWnd ھΪʱʾĻ
            * @param captureFreq Ļ֡ʣȡֵ1~15
            * @param rect Ļָ򣬽 hWnd=null ʱЧ
            * @param bitrate ĻʣλkbpsΪ0SDKݹĻķֱʼ֡ʼ
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int StartScreenCapture(HWND hWnd, int captureFreq, const RECT* rect, int bitrate = 0);

            /**
            * ֹͣĻ
            *
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int StopScreenCapture();

            /**
            * Ļͼ
            *
            * @param rect ֻڵ startScreenCapture() ʱ hWnd Ϊ 0 ʱòЧ rect Ϊ null ʱ, Ļ
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int UpdateScreenCaptureRegion(const RECT *rect);

#pragma endregion Ƶ߼ӿ-Ļ

#pragma region Ƶ߼ӿ-

            /**
            * ʼŰָ࣬Ƶļ˷ɼƵл滻(Ƶļ滻˷ɼƵ)
            * ͨѡǷöԷزŵƵָѭŵĴ
            *
            * @param filePath Ƶļ·
            * @param loopback true زŵƵ
            *                 false غͶԷزŵƵ
            * @param replace true زŵƵ滻˷ɼƵ
            *                false زŵƵ˷ɼƵл
            * @param cycle ѭŴ-1ʾѭ
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int StartAudioMixing(const char* filePath, bool loopback, bool replace, int cycle);

            /**
            * ֹͣŰ
            *
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int StopAudioMixing();

            /**
            * ͣŰ
            *
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int PauseAudioMixing();

            /**
            * ָŰ
            *
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int ResumeAudioMixing();

            /**
            * ڰ
            *
            * @param volume Χ0-100Ĭ100
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int AdjustAudioMixingVolume(int volume);

            /**
            * ȡʱλ
            *
            * @return ذʱ0ʾʧ
            */
            QHVC_API int GetAudioMixingDuration();

            /**
            * ȡಥŽȣλ
            *
            * @return صǰŽȣ0ʾʧ
            */
            QHVC_API int GetAudioMixingCurrentPosition();

            /**
            * ðಥλãλ
            *
            * @param position λãλ
            * @param
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetAudioMixingPosition(int position);

#pragma endregion

#pragma region Ƶ߼ӿ-Ч
            /**
            * ÷ȡЧΧΪ [0.0, 100]
            * @return Ч
            */
            QHVC_API int GetEffectsVolume();

            /**
            * ÷Ч
            * @param volume , ȡֵΧΪ [0.0, 100] 100.0ΪĬֵ
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetEffectsVolume(int volume);

            /**
            * ÷ʵʱָЧ
            * @param soundId ָЧ IDÿЧΨһ ID
            * @param volume ȡֵΧΪ [0.0, 100] 100 ΪĬֵ
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int SetVolumeOfEffect(int soundId, int volume);

            /**
            * ÷ָЧ
            * @param soundId ָЧ IDÿЧΨһIDͨ preloadEffect Чڴ棬ȷõ soundId  preloadEffect õ soundId ͬ
            * @param filePath Чļľ·
            * @param loopCount ЧѭŵĴ
            *       0Чһ
            *       1ѭЧ
            *       -1ѭЧֱ stopEffect  stopAllEffects ֹͣ
            * @param pitch Ч ȡֵΧΪ [0.5, 2]ĬֵΪ 1.0ʾҪ޸ȡֵԽСԽ
            * @param pan   ǷıЧĿռλáȡֵΧΪ [-1, 1]
            *       0Чǰ
            *       -1Ч
            *       1Чұ
            * @param gain Ƿı䵥ЧȡֵΧΪ [0.0, 100.0]ĬֵΪ 100.0ȡֵԽСЧԽ
            * @param publish ǷЧԶˣ
            *       trueЧڱزŵͬʱᷢϣԶûҲЧ
            *       falseЧᷢϣֻڱЧ
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int PlayEffect(int soundId, const char* filePath, int loopCount, double pitch, double pan, double gain, bool publish);

            /**
            * ÷ָֹͣЧ
            * @param soundId  ָЧ IDÿЧΨһ ID
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int StopEffect(int soundId);

            /**
            * ÷ֹͣЧ
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int StopAllEffects();

            /**
            *  ԤЧ
            *  ÷ָЧļ(ѹļ)Ԥڴ档
            * @param soundId ָЧ IDÿЧΨһ ID
            * @param filePath Чļľ·
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int PreloadEffect(int soundId, const char* filePath);

            /**
            * ÷ָԤصЧڴͷų
            * @param soundId  ָЧ IDÿЧΨһ ID
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int UnloadEffect(int soundId);

            /**
            * ÷ָͣЧ
            * @param soundId ָЧ IDÿЧΨһ ID
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int PauseEffect(int soundId);

            /**
            * ÷ͣЧ
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int PauseAllEffects();

            /**
            * ÷ָָЧ
            * @param soundId ָЧ IDÿЧΨһID
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int ResumeEffect(int soundId);

            /**
            * ָЧ
            * @return 0óɹʾʧܣ@link QHVC#INTERACT#ERR
            */
            QHVC_API int ResumeAllEffects();

#pragma endregion

#pragma region 豸

            /**
            * ͷ豸б
            *
            * @param [in] 豸б
            */
            QHVC_API void FreeDeviceList(__in DeviceInfo* parrDeviceList);

            /**
            * ȡƵ豸б
            *
            * @param [out] Ƶ豸
            * @return Ƶ豸б
            */
            QHVC_API DeviceInfo* GetVideoDeviceList(__out int& deviceCount);

            /**
            * ȡǰƵ豸
            *
            * @param deviceId 豸ID
            * @param length deviceId
            * @return 0 ɹο{@link INTERACT::Err} 
            */
            QHVC_API int GetVideoDevice(__out char* deviceId, int length);

            /**
            * õǰƵ豸
            *
            * @param deviceId 豸ID
            * @return 0 ɹο{@link INTERACT::Err} 
            */
            QHVC_API int SetVideoDevice(__in const char* deviceId);

            /**
            * ȡƵ豸б
            *
            * @param deviceType [in] Ƶ豸ͣ豸
            * @param deviceCount [out] Ƶ豸
            * @return Ƶ豸б
            */
            QHVC_API DeviceInfo* GetAudioDeviceList(__in AUDIO_DEVICE_TYPE deviceType, __out int& deviceCount);

            /**
            * ȡǰƵ豸
            *
            * @param deviceType [in] Ƶ豸ͣ豸
            * @param deviceId 豸ID
            * @param length deviceId
            * @return 0 ɹο{@link INTERACT::Err} 
            */
            QHVC_API int GetAudioDevice(__in AUDIO_DEVICE_TYPE deviceType, __out char* deviceId, int length);

            /**
            * õǰƵ豸
            *
            * @param deviceType [in] Ƶ豸ͣ豸
            * @param deviceId 豸ID
            * @return 0 ɹο{@link INTERACT::Err} 
            */
            QHVC_API int SetAudioDevice(__in AUDIO_DEVICE_TYPE deviceType, __in const char* deviceId);

            /**
            * ȡǰƵ豸
            *
            * @param deviceType [in] Ƶ豸ͣ豸
            * @param volume [out] 0~255
            * @return 0 ɹο{@link INTERACT::Err} 
            */
            QHVC_API int GetAudioDeviceVolume(__in AUDIO_DEVICE_TYPE deviceType, __out int& volume);

            /**
            * õǰƵ豸
            *
            * @param deviceType [in] Ƶ豸ͣ豸
            * @param volume [in] 0~255
            * @return 0 ɹο{@link INTERACT::Err} 
            */
            QHVC_API int SetAudioDeviceVolume(__in AUDIO_DEVICE_TYPE deviceType, __in int volume);

            /**
            * ȡǰ豸Ƿ
            *
            * @param deviceType [in] Ƶ豸ͣ豸
            * @param mute [out] true false Ǿ
            * @return 0 ɹο{@link INTERACT::Err} 
            */
            QHVC_API int GetAudioDeviceMute(__in AUDIO_DEVICE_TYPE deviceType, __out bool& mute);

            /**
            * õǰ豸Ƿ
            *
            * @param deviceType [in] Ƶ豸ͣ豸
            * @param mute [in] true false Ǿ
            * @return 0 ɹο{@link INTERACT::Err} 
            */
            QHVC_API int SetAudioDeviceMute(__in AUDIO_DEVICE_TYPE deviceType, __in bool mute);
#pragma endregion 豸
        }
    }
}

#endif