#ifndef _QHVC_INTERACT_CALLBACK_H_
#define _QHVC_INTERACT_CALLBACK_H_

#pragma once

#include "QHVCInteractConstant.h"

namespace QHVC
{
    namespace INTERACT
    {
        /**
        * ͨͳϢ
        */
        typedef struct RtcStats
        {
            unsigned int totalDuration;         //ۼͨʱ()
            unsigned int txBytes;               //ۼƷֽ(bytes)
            unsigned int rxBytes;               //ۼƽֽ(bytes)
            unsigned int txKBitRate;            //(kbps)˲ʱֵ
            unsigned int rxKBitRate;            //(kbps)˲ʱֵ

            unsigned int txAudioKBitRate;       //Ƶ(kbps)˲ʱֵ
            unsigned int rxAudioKBitRate;       //Ƶ(kbps)˲ʱֵ
            unsigned int txVideoKBitRate;       //Ƶ(kbps)˲ʱֵ
            unsigned int rxVideoKBitRate;       //Ƶ(kbps)˲ʱֵ

            int users;                          //û
            double cpuTotalUsage;               //ǰϵͳCPUʹ(%)
            double cpuAppUsage;                 //ǰӦóCPUʹ(%)

            RtcStats()
            {
                ZeroMemory(this, sizeof(RtcStats));
            }
        } RtcStats;

        /**
        * ƵͳϢ
        */
        typedef struct LocalVideoStats
        {
            unsigned int sentBitrate;           //ϴͳƺֽ(bytes)
            unsigned int sentFrameRate;         //ϴͳƺ͵֡
            unsigned int packageLost;           //ϴͳƺ󶪰

            LocalVideoStats()
            {
                ZeroMemory(this, sizeof(LocalVideoStats));
            }
        } LocalVideoStats;

        /**
        * ԶƵͳϢ
        */
        typedef struct RemoteVideoStats
        {
            char userId[64];                    //ûID
            unsigned int delay;                 //ӳ
            unsigned int width;                 //Ƶֱ-
            unsigned int height;                //Ƶֱ-
            unsigned int receivedBitrate;       //ϴͳƺֽܵ(byte)
            unsigned int receivedFrameRate;     //ϴͳƺܵ֡
            VIDEO_STREAM_LEVEL rxStreamType;    //Ƶȼ
            QUALITY quality;                    //Ƶ

            RemoteVideoStats()
            {
                ZeroMemory(this, sizeof(RemoteVideoStats));
            }
        } RemoteVideoStats;

        /**
        * ƵϢ
        */
        typedef struct AudioVolumeInfo
        {
            char userId[64];;                   //ûID
            unsigned int volume;                //

            AudioVolumeInfo()
            {
                ZeroMemory(this, sizeof(AudioVolumeInfo));
            }
        } AudioVolumeInfo;

        class IQHVCInteractCallback
        {
        public:
            /**
            * ص
            * עûصʾSDKʱˣýصģ档ͨ£SDKϱľϢӦóԺԣSDKԶָ
            *
            * @param warn 룬ο{@link INTERACT::WARN}
            * @param msg Ϣ
            */
            virtual void OnWarning(int warn, const char* msg) = 0;

            /**
            * ص
            * עûصʾSDKʱˣýصģͨ£SDKϱĴζSDK޷ԶָҪӦóԤ
            * ʾû
            *
            * @param error 룬ο{@link INTERACT::ERR}
            * @param msg Ϣ
            */
            virtual void OnError(int error, const char* msg) = 0;

            /**
            * ػֱɹʱҵ񷽿Խһϵвã֮{@link JoinChannel}
            *
            * @param roomId ID
            * @param userId ûID
            */
            virtual void OnLoadEngineSuccess(const char* roomId, const char* userId) = 0;

            /**
            * 뷿ɹ
            *
            * @param roomId ID
            * @param userId ûID
            * @param elapsed {@link JoinChannel}ʼ¼ӳ٣λ
            */
            virtual void OnJoinChannelSuccess(const char* roomId, const char* userId, long elapsed) = 0;

            /**
            * ¼뷿ɹԭ򣬿ͻ˿ܻͷʧȥӣSDKԶԶɹ󴥷˻ص
            *
            * @param roomId ID
            * @param userId ûID
            * @param elapsed {@link JoinChannel}ʼ¼ӳ٣λ
            */
            virtual void OnRejoinChannelSuccess(const char* roomId, const char* userId, long elapsed) = 0;

            /**
            * 뿪ص
            *
            * @param rtcStats ͨصͳϢ
            */
            virtual void OnLeaveChannel(const RtcStats& rtcStats) = 0;

            /**
            * ɫлɹص
            * {@link SetClientRole}лɫʱлɹص˷лʧܣصonError()
            * עֻмƵɹ֮лݲŻд˻ص
            *
            * @param clientRole ıĽɫ
            */
            virtual void OnChangeClientRoleSuccess(CLIENT_ROLE clientRole) = 0;

            /**
            * жϻصûصʾSDKͷʧȥӡʧȥӺ󣬳Ӧó{@link LeaveChannel}
            * SDKһֱԶ
            */
            virtual void OnConnectionInterrupted() = 0;

            /**
            * ӶʧصûصʾSDKͷʧȥӣҳԶһʱ䣨Ĭ10룩δ
            *
            * @param error 룬ο{@link INTERACT::ERR}
            */
            virtual void OnConnectionLost(int error) = 0;

            /**
            * û뵱ǰ
            * עǰû뷿ʱѾڷڣSDKҲӦóϱڷеû
            *
            * @param userId ûID
            * @param elapsed {@link JoinChannel}ʼ¼ӳ٣λ
            */
            virtual void OnUserJoined(const char* userId, long elapsed) = 0;

            /**
            * û뿪ǰ
            * עSDKжû뿪ݣһʱڣ15룩ûյԷκݰжΪԷߡϲ
            * £ܴ󱨡ɿĵ߼Ӧóͨ
            *
            * @param userId ûID
            * @param userOfflineReason û뿪ԭ
            */
            virtual void OnUserOffline(const char* userId, USER_OFFLINE_REASON userOfflineReason) = 0;

            /**
            * û/رƵ
            * ע:رƵָûֻܽͨʾԼƵҲܽձ˵Ƶ
            *
            * @param userId ûID
            * @param enabled true Ƶfalse رƵ
            */
            virtual void OnUserEnableVideo(const char* userId, bool enabled) = 0;

            /**
            * ûص
            *
            * @param userId ûID
            * @param muted true ûƵfalse ûȡƵ
            */
            virtual void OnUserMuteAudio(const char* userId, bool muted) = 0;

            /**
            * ûֹ/Ƶص
            *
            * @param userId ûID
            * @param muted true ûֹƵͣfalse ûƵ
            */
            virtual void OnUserMuteVideo(const char* userId, bool muted) = 0;

            /**
            * ͷûصԿʼƵ
            */
            virtual void OnCameraReady() = 0;

            /**
            * Ƶֹͣص
            */
            virtual void OnVideoStopped() = 0;

            /**
            * Ƶʾصһ֡ƵѾʾĻ
            *
            * @param width Ƶȣλ
            * @param height Ƶ߶ȣλ
            * @param elapsed Ӽ뷿俪ʼ¼ӳ٣λ
            */
            virtual void OnFirstLocalVideoFrame(int width, int height, int elapsed) = 0;

            /**
            * ԶƵʾصһ֡ԶƵѾʾĻ
            *
            * @param userId ûID
            * @param width Ƶȣλ
            * @param height Ƶ߶ȣλ
            * @param elapsed Ӽ뷿俪ʼ¼ӳ٣λ
            */
            virtual void OnFirstRemoteVideoFrame(const char* userId, int width, int height, int elapsed) = 0;

            /**
            * ԶƵղصӦóڴ˻صøûViewHWND
            *
            * @param userId ûID
            * @param width Ƶȣλ
            * @param height Ƶ߶ȣλ
            * @param elapsed Ӽ뷿俪ʼ¼ӳ٣λ
            */
            virtual void OnFirstRemoteVideoDecoded(const char* userId, int width, int height, int elapsed) = 0;

            /**
            * ƵͳϢص
            *
            * @param stats ƵͳϢ
            */
            virtual void OnLocalVideoStats(const LocalVideoStats& stats) = 0;

            /**
            * ԶƵͳϢص
            *
            * @param stats ԶƵͳϢ
            */
            virtual void OnRemoteVideoStats(const RemoteVideoStats& stats) = 0;

            /**
            * Ƶصͨÿ봥һΣ浱ǰͨƵ
            *
            * @param userId ûID
            * @param quality Ƶ
            * @param delay ӳ٣λ
            * @param lost ʣٷֱ
            */
            virtual void OnAudioQuality(const char* userId, QUALITY quality, unsigned short delay, unsigned short lost) = 0;

            /**
            * ˵ص
            *
            * @param speakers ˵
            * @param totalVolume 0-255
            */
            virtual void OnAudioVolumeIndication(const AudioVolumeInfo* speakers, int speakerNumber, unsigned int totalVolume) = 0;

            /**
            * ͳݻصûصϱSDK״̬ÿ2-3봥һ
            *
            * @param stats ͨͳϢ
            */
            virtual void OnRtcStats(const RtcStats& stats) = 0;

            /**
            * ص
            *
            * @param userId ûID
            * @param txQuality 
            * @param rxQality 
            */
            virtual void OnNetworkQuality(const char* userId, QUALITY txQuality, QUALITY rxQuality) = 0;

            /**
            * Ƶ豸״̬ı
            *
            * @param deviceId 豸ID
            * @param deviceType Ƶ豸ͣ豸
            * @param deviceState Ƶ豸״̬ááڡγ
            */
            virtual void OnAudioDeviceStateChanged(const char* deviceId, AUDIO_DEVICE_TYPE deviceType, DEVICE_STATE deviceState) = 0;

            /**
            * Ƶ豸״̬ı
            *
            * @param deviceId 豸ID
            * @param deviceState Ƶ豸״̬ááڡγ
            */
            virtual void OnVideoDeviceStateChanged(const char* deviceId, DEVICE_STATE deviceState) = 0;

            /**
            * ಥŽ
            */
            virtual void OnAudioMixingFinished() = 0;

            /**
            * ûʼŰ
            */
            virtual void OnRemoteAudioMixingBegin() = 0;

            /**
            * ûŰ
            */
            virtual void OnRemoteAudioMixingEnd() = 0;

            /**
            * ЧŽ
            */
            virtual void OnAudioEffectFinished(int soundId) = 0;
        };

        class IQHVCInteractLocalVideoRenderCallback
        {
        public:
            /**
            * Ƶݻصڻͷɼͼ
            * @param videoFrame Ƶ
            * @return true:  óɹflaseʾʧ
            */
            virtual bool OnCaptureVideoFrame(VideoFrame& videoFrame) = 0;
        };

        class IQHVCInteractRemoteVideoRenderCallback
        {
        public:
            /**
            * ԶݻصڻûƵ
            * @param userId ûID
            * @param videoFrame Ƶ
            * @return true:  óɹflaseʾʧ
            */
            virtual bool OnRenderVideoFrame(const char* userId, VideoFrame& videoFrame) = 0;
        };

        class IQHVCInteractAudioFrameCallback
        {
        public:
            /**
            *  ص
            * @param AudioFrame Ƶ
            * @return true:  óɹflaseʾʧ
            */
            virtual bool OnAudioFrame(AudioFrame& audioFrame) = 0;

            /**
            *  ʱأԼģص
            * @param AudioFrame Ƶ
            * @return true:  óɹflaseʾʧ
            */
            virtual bool OnLocalAudioFrame(AudioFrame& audioFrame) = 0;
        };
    }
}

#endif
